package com.perforce.p4simulink.util;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

import com.perforce.p4java.client.IClient;

public class ClientRequiredProcessor {
	public static void processAnnotations(Object obj) {
		try {
			Class<? extends Object> cl = obj.getClass();
			for (Method method : cl.getDeclaredMethods()) {
				for (Annotation annotation : cl.getAnnotations()) {
					try {
						if (annotation.annotationType() == ClientRequired.class) {
							// might need to check private methods
							method.setAccessible(true);
							Field client = cl.getDeclaredField("client");
							client.setAccessible(true);

							// client value is null, so generate it and assign
							if (client.get(obj) == null) {
								Method getClient = cl
										.getDeclaredMethod("getClient");
								client.set(obj, (IClient) getClient.invoke(obj));
							}
						}
					} catch (NoSuchFieldException e) {
						// no client field declared, so don't worry about it
					}
				}
			}
		} catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
}
